#include<SDL.h>
#include<stdlib.h>



SDL_Color * Uint32toColor(SDL_Surface* s, Uint32 c){
return &s->format->palette->colors[(c>s->format->palette->ncolors)?s->format->palette->ncolors:c];
}

SDL_Surface * SDL_CreateSurface(int width, int height){
 /* Create a 32-bit surface with the bytes of each pixel in R,G,B,A order,
       as expected by OpenGL for textures */
    SDL_Surface *surface;
    SDL_Surface *surfaceaux;
    Uint32 rmask, gmask, bmask, amask;

    /* SDL interprets each pixel as a 32-bit number, so our masks must depend
       on the endianness (byte order) of the machine */
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
    rmask = 0xff000000;
    gmask = 0x00ff0000;
    bmask = 0x0000ff00;
    amask = 0x000000ff;
#else
    rmask = 0x000000ff;
    gmask = 0x0000ff00;
    bmask = 0x00ff0000;
    amask = 0xff000000;
#endif

    surface = SDL_CreateRGBSurface(SDL_HWSURFACE, width, height, 32,
                                   rmask, gmask, bmask, amask);
    surfaceaux= SDL_DisplayFormat(surface);
    if(surface == NULL) {
        fprintf(stderr, "CreateRGBSurface failed: %s\n", SDL_GetError());
        exit(1);
    }
    SDL_FreeSurface(surface);
    if(surfaceaux == NULL) {
        fprintf(stderr, "ConvertSurface failed: %s\n", SDL_GetError());
        exit(1);
    }
return surfaceaux;
}

/* This is a way of telling whether or not to use hardware surfaces */
Uint32
FastestFlags (Uint32 flags, int width, int height, int bpp)
{
	const SDL_VideoInfo *info;

	/* Hardware acceleration is only used in fullscreen mode */
	flags |= SDL_FULLSCREEN;

	/* Check for various video capabilities */
	info = SDL_GetVideoInfo ();
	if (info->blit_hw_CC && info->blit_fill)
	  {
		  /* We use accelerated colorkeying and color filling */
		  flags |= SDL_HWSURFACE;
	  }
	/* If we have enough video memory, and will use accelerated
	   blits directly to it, then use page flipping.
	 */
	if ((flags & SDL_HWSURFACE) == SDL_HWSURFACE)
	  {
		  /* Direct hardware blitting without double-buffering
		     causes really bad flickering.
		   */
		  if (info->video_mem * 1024 > (height * width * bpp / 8))
		    {
			    flags |= SDL_DOUBLEBUF;
		    }
		  else
		    {
			    flags &= ~SDL_HWSURFACE;
		    }
	  }

	/* Return the flags */
	return (flags);
}




