#ifndef PUNE_COLLIDE
#define PUNE_COLLIDE
#include<stdlib.h>
#include<SDL.h>
#include<id.h>

struct collide{
    id* map;
    int h;
    int w;
};
typedef struct  collide * collide;
 
void collide_clean(collide collide);

collide collide_init(int w, int h){
    collide collide;
    collide=malloc(sizeof(struct collide));
    collide->map=malloc(sizeof(ID)*w*h);
    collide->w=w;
    collide->h=h;
    collide_clean(collide);
return collide;
};

void collide_destroy(collide collide){
    free(collide->map);
    free(collide);
};

int clip(collide collide, SDL_Rect * rect){
    if (rect->x<0){
	if(rect->x+rect->w < 0)
    	    return 0;	//is out
        rect->x = 0;
    }
    if (rect->y<0){
	if(rect->y+rect->h < 0)
	    return 0;	//is out
        rect->y = 0;
    }

    if (rect->x+rect->w >= collide->w){
	if(rect->x >= collide->w)
	    return 0;	//is out
        rect->w -= (rect->x+rect->w) - collide->w -1;
    }
    if (rect->y+rect->h >= collide->h){
	if(rect->y >= collide->h)
	    return 0;	//is out
	rect->h -= (rect->y+rect->h) - collide->h -1;
    }
return 1;
}

int check(collide collide, SDL_Rect * rect){
    if (rect->x<0)
    	    return 0;	//is out
    if (rect->y<0)
	    return 0;	//is out
    if (rect->x+rect->w >= collide->w)
	    return 0;	//is out
    if (rect->y+rect->h >= collide->h)
	    return 0;	//is out
return 1;
}


#define COLLIDE(x,y) collide->map[(collide->w*y)+x]
id collide_do(collide collide, SDL_Rect rect){
    int i,j;
    if(!check(collide,&rect))
	return WALL;
    for(i=rect.x;i<(rect.w+rect.x);i++)
        for(j=rect.y;j<(rect.h+rect.y);j++)
	    if(COLLIDE(i,j)!=NONE){
		return COLLIDE(i,j);
		}
return NONE;
};
int collide_ndo(collide, SDL_Rect, int max, id * ids); //not implemented

id collide_who(collide collide, int x, int y){
    if(x>=collide->w || y>=collide->h || x<0 ||y<0)
	return WALL;
return COLLIDE(x,y);
};

void collide_put(collide collide, SDL_Rect rect, id id){
    int i,j;
    if(!clip(collide,&rect))
	return ;
    for(i=rect.x;i<(rect.w+rect.x);i++)
        for(j=rect.y;j<(rect.h+rect.y);j++)
	    COLLIDE(i,j)=id;
};
void collide_cut(collide collide, SDL_Rect rect){
    collide_put(collide, rect, NONE);
};


int collide_getwidth(collide collide){
    return collide->w;    
};
int collide_getheight(collide collide){
    return collide->h;    
};
void collide_clean(collide collide){
    int i;
    id * map;
    int size = collide->w*collide->h;
    map=collide->map;
    for(i=0;i<size;i++)
	map[i]=NONE;
};


#endif
