#ifndef _PUNE_COUNTER_
#define _PUNE_COUNTER_
#include<SDL.h>
#include<SDL_ttf.h>
#include<SDL_utils.h>
#include<action.h>
#include<world.h>
#include<display.h>
#include<object.h>
#include<math.h>

#define _COUNTER_C_
struct counter{
    world world;
    display display;
    float x,y;
    int ptsize;
    id id;
    id buddy;
    int count;
    int dirty;
    Uint32 color;
    TTF_Font *font;
    int renderstyle;
};

typedef struct counter * counter;
#include<counter.h>


counter counter_init(world world, display display, id idp, id buddy, int x, int y, Uint32 color){
    counter counter=malloc(sizeof(struct counter));
    counter->world=world;
    counter->display=display;
    counter->x=x;
    counter->y=y;
    counter->ptsize = 72;
    counter->color=color;
    counter->renderstyle=0;//RENDER_UNICODE|TTF_STYLE_BOLD|TTF_STYLE_ITALIC;
    counter->id=idp;
    counter->buddy=buddy;
    counter->count=0;
    counter->dirty=1;
    counter->font = TTF_OpenFont("./resources/Vera.ttf", counter->ptsize);
    if(!counter->font)
	{
	printf("Unable to load the font!\n");
	exit(-1);
	}
    TTF_SetFontStyle(counter->font, counter->renderstyle);
    return counter;
};
void counter_destroy(counter counter){
//free font??
    free(counter);
};


int counter_alive(counter counter){
//counter_show(counter);
    return 1;
};


extern void * screen;
int counter_show(counter counter){
SDL_Surface *text;
SDL_Rect dstrect;
SDL_Color col;
char  buf[20];
//SDL_GetRGB(counter->color,&ScreenFormat,&col.r,&col.g,&col.b);
col.r=0x0;
col.g=0xff;
col.b=0x0;
text = TTF_RenderText_Solid(counter->font,(sprintf(buf,"%d",counter->count),buf), col /*-Uint32toColor(screen,counter->color)-*/);
	if ( text != NULL ) {
		dstrect.x = counter->x;
		dstrect.y = counter->y;
		dstrect.w = text->w;
		dstrect.h = text->h;
		display_clean_rect(counter->display,&dstrect);
		display_blit(counter->display,text,NULL,&dstrect);
		display_update(counter->display);
		SDL_FreeSurface(text);
	}
counter->dirty=0;
return 1;
};

int counter_step(counter counter){
if(counter->dirty)counter_show(counter);
return 1;
};

int counter_action(counter counter, SDL_Event * event){
    if (event->type ==  SDL_USEREVENT) 
	if (event->user.code== DEAD)
	    if(counter->buddy!=player_getid(event->user.data1)){
	    counter->count++;  //+=event->data1
	    counter->dirty=1;
	    }
    else 
	return 0;
    return 1;
};

#endif
