#include<stdlib.h>
#include<SDL.h>
#include<SDL_utils.h>

#define DBG(x) x

#define _DISPLAY_C_
#define MAX_UPDRECT 100
struct display
{
	SDL_Surface * screen;
	SDL_Surface * display;
        SDL_Surface * background;
	SDL_Rect viewport;
	int w,h;
	int scrollx, scrolly;
	Uint32 col;
	
// Using a list is too slow??? malloc/free...	
	SDL_Rect rects[MAX_UPDRECT];
	int nrects;
	
};

typedef struct display * display;

#include<display.h>


void display_clean(display);

display
display_init(SDL_Surface * screen, int w, int h, SDL_Rect viewport){
    display display=malloc(sizeof(struct display));
    display->screen=screen;
    display->viewport=viewport;
    display->background=NULL;
    display->col = SDL_MapRGB (screen->format, 0x00, 0x00, 0x00);
    display->h=h;
    display->w=w;
    display->scrollx=0;
    display->scrolly=0;
    display->display=SDL_CreateSurface(w,h);
    display->nrects=0;
    display_clean(display);    
return display;
}

SDL_Surface *
display_destroy(display display){
SDL_Surface * surface;
    surface= display->screen;
    free(display);
return surface;
}

int 
display_setbackground(display display, char * background){
    if(display->background)
	SDL_FreeSurface(display->background);
    display->background=SDL_LoadBMP(background);
    return (display->background!=NULL);
};

void
display_setbackgroundcolor(display display, Uint32 col){
    display->col=col;
    display->background=NULL;
};

int
display_width(display display){
    return display->w;
}

int
display_height(display display){
    return display->h;
}


SDL_Rect
display_viewport(display display){
    return display->viewport;
};

int
display_scroll(display display, int x, int y){
    display->scrollx=x;
    display->scrolly=y;
return 0;
};

void
display_blit(display display, SDL_Surface * sprite, SDL_Rect * rect, SDL_Rect * pos){
    SDL_BlitSurface (sprite, rect, display->display, pos);
    display->rects[display->nrects++]=*pos;
    if(display->nrects>=100){
	display_update(display);
	DBG(printf("Display update rects overflow!!Code: 028764\n"));
    }
}

void
display_draw(display display, SDL_Surface * sprite, SDL_Rect * pos){
    SDL_BlitSurface (sprite, NULL, display->display, pos);
    display->rects[display->nrects++]=*pos;
    if(display->nrects>=100){
	display_update(display);
	DBG(printf("Display update rects overflow!!Code: 028764\n"));
    }
}

int
display_update(display display){
int i;
SDL_Rect rect;
    for(i=display->nrects-1;i>=0;i--){
	rect=display->rects[i];
	rect.x=rect.x - display->scrollx + display->viewport.x;
	rect.y=rect.y - display->scrolly + display->viewport.y;
	SDL_BlitSurface (display->display, &display->rects[i], display->screen, &rect);
        SDL_UpdateRects (display->screen, 1, &rect);
    }
    display->nrects=0;
return 0;    
};

void 
tile (SDL_Surface * tile, SDL_Surface * dst){
SDL_Rect rect;
for (rect.w=tile->w,rect.x=0;rect.x<=dst->w; rect.x+=tile->w)
    for (rect.y=tile->h,rect.y=0;rect.y <=dst->h;rect.y+=tile->h)
	SDL_BlitSurface (tile, NULL, dst, &rect);

}




void
display_clean_rect(display display, SDL_Rect * rect){
    display->nrects=1;
    display->rects[0].x=0;
    display->rects[0].y=0;
    display->rects[0].w=display->display->w;
    display->rects[0].h=display->display->h;
if(display->background){
//    SDL_BlitSurface (display->background, NULL, display->display, NULL);
    tile(display->background, display->display); //BUG!!
    }
else
    SDL_FillRect (display->display, rect, display->col);
};


void
display_clean(display display){
    display->nrects=1;
    display->rects[0].x=0;
    display->rects[0].y=0;
    display->rects[0].w=display->display->w;
    display->rects[0].h=display->display->h;
if(display->background){
//    SDL_BlitSurface (display->background, NULL, display->display, NULL);
    tile(display->background, display->display);
    }
else
    SDL_FillRect (display->display, NULL, display->col);
};


SDL_Surface * pixel=NULL;
SDL_Rect pixelrect1= {0,0,1,1};
Uint32
display_getpixel(display display, int x, int y){
SDL_Rect pixelrect= pixelrect1;

    if(!pixel)
    	pixel=SDL_LoadBMP("resources/pixel.bmp");
    pixelrect.x=x;
    pixelrect.y=y;
    pixelrect.w=1;
    pixelrect.h=1;
    SDL_BlitSurface (display->display, &pixelrect, pixel, NULL);
return *((Uint32 *)pixel->pixels);
};

SDL_Surface *
display_get(display display, SDL_Surface * sprite, SDL_Rect * pos){
    SDL_BlitSurface (display->display, pos, pixel, NULL);
return sprite;
};


void
display_drawpixel(display display, int x, int y, Uint32 color){
SDL_Rect pixelrect= pixelrect1;
    if(!pixel)
	pixel=SDL_LoadBMP("resources/pixel.bmp");
    pixelrect.x=x;
    pixelrect.y=y;
    pixelrect.w=2;
    pixelrect.h=2;
    SDL_FillRect (pixel, NULL, color);
    display_draw(display, pixel, &pixelrect);
}

