#ifndef _DISPLAY_
#define _DISPLAY_

#include<stdlib.h>
#include<SDL.h>

/*Probablemente muchos contructores(no solo este) esperen un tipo "resources",
y luego, muchas de las funciones lo usan para obtener las SDL_Surface y demas*/


#ifndef _DISPLAY_C_
typedef void * display;
#endif /* _DISPLAY_C_ */

//viewport es el rect de la screen que se usa
//h,w, es el tamanio usado en la screen, x,y es la pos en la screen
//h,w es el tamanio real del display(tener en cuenta el scroll)


display
display_init(SDL_Surface * screen, int h, int w, SDL_Rect viewport);

SDL_Surface *
display_destroy(display);

int 
display_setbackground(display, char *);

void
display_setbackgroundcolor(display, Uint32 col);

int
display_width(display);

int
display_height(display);

SDL_Rect
display_viewport(display);

int
display_scroll(display, int x, int y);

void
display_draw(display, SDL_Surface * sprite, SDL_Rect * pos);

void
display_blit(display, SDL_Surface * sprite, SDL_Rect * rect, SDL_Rect * pos);


SDL_Surface *
display_get(display, SDL_Surface * sprite, SDL_Rect * pos);


Uint32
display_getpixel(display, int, int);

void
display_drawpixel(display, int, int, Uint32);



int
display_update(display);

void
display_clean(display);

void
display_clean_rect(display,SDL_Rect *);

#endif
