
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#include "SDL.h"
#include <SDL_utils.h>
#include <world.h>
#include <player.h>
#include <counter.h>



	SDL_Surface *screen;
int
main (int argc, char *argv[])
{

	Uint8 *mem;
	int width, height;
	Uint8 video_bpp;
	Uint32 videoflags;
//	Uint32 background;
	int i, done;
	SDL_Event event;
	Uint32 then, now, frames;
	int anchito, altito;
	SDL_Rect rec;

	/* Initialize SDL */
	if (SDL_Init (SDL_INIT_VIDEO) < 0)
	  {
		  fprintf (stderr, "Couldn't initialize SDL: %s\n",
			   SDL_GetError ());
		  exit (1);
	  }
	atexit (SDL_Quit);

	videoflags = SDL_SWSURFACE | SDL_ANYFORMAT;
	width = 1024;//640;
	height = 768;//480;
	video_bpp = 8;
	while (argc > 1)
	  {
		  --argc;
		  if (strcmp (argv[argc - 1], "-width") == 0)
		    {
			    width = atoi (argv[argc]);
			    --argc;
		    }
		  else if (strcmp (argv[argc - 1], "-height") == 0)
		    {
			    height = atoi (argv[argc]);
			    --argc;
		    }
		  else if (strcmp (argv[argc - 1], "-bpp") == 0)
		    {
			    video_bpp = atoi (argv[argc]);
			    videoflags &= ~SDL_ANYFORMAT;
			    --argc;
		    }
		  else if (strcmp (argv[argc], "-fast") == 0)
		    {
			    videoflags =
				    FastestFlags (videoflags, width, height,
						  video_bpp);
		    }
		  else if (strcmp (argv[argc], "-hw") == 0)
		    {
			    videoflags ^= SDL_HWSURFACE;
		    }
		  else if (strcmp (argv[argc], "-flip") == 0)
		    {
			    videoflags ^= SDL_DOUBLEBUF;
		    }
		  else if (strcmp (argv[argc], "-fullscreen") == 0)
		    {
			    videoflags ^= SDL_FULLSCREEN;
		    }
		  else
		    {
			    fprintf (stderr,
				     "Usage: %s [-width W] [-height H] [-bpp N] [-hw] [-flip] [-fast] [-fullscreen] \n",
				     argv[0]);
			    exit (1);
		    }
	  }

	/* Set video mode */
	screen = SDL_SetVideoMode (width, height, video_bpp, videoflags);
	if (!screen)
	  {
		  fprintf (stderr, "Couldn't set %dx%d video mode: %s\n",
			   width, height, SDL_GetError ());
		  exit (2);
	  }

//	background = SDL_MapRGB (screen->format, 0x00, 0x00, 0x00);

	/* Print out information about our surfaces */
	printf ("Screen is at %d bits per pixel\n",
		screen->format->BitsPerPixel);
	if ((screen->flags & SDL_HWSURFACE) == SDL_HWSURFACE)
	  {
		  printf ("Screen is in video memory\n");
	  }
	else
	  {
		  printf ("Screen is in system memory\n");
	  }
	if ((screen->flags & SDL_DOUBLEBUF) == SDL_DOUBLEBUF)
	  {
		  printf ("Screen has double-buffering enabled\n");
	  }

	printf("Screen is at %dx%d.\n",screen->w,screen->h);


	/* Initialize the TTF library */
	if ( TTF_Init() < 0 ) {
		fprintf(stderr, "Couldn't initialize TTF: %s\n",SDL_GetError());
		return(2);
	}

	/* Loop, blitting sprites and waiting for a keystroke */
	then = SDL_GetTicks ();

{
//@@@

int INIT_NPLAYERS;
    char INIT_PLAYER_NAME[256];
    int INIT_PLAYER_COLOR;
    int INIT_PLAYER_POSX;
    int INIT_PLAYER_POSY;
    int INIT_PLAYER_LEFTKEY;
    int INIT_PLAYER_RIGHTKEY;

int i;
FILE * initfile;

int aa;
SDL_Rect rect;
SDL_Rect rectc;
world world;
display displayc;
display display;
collide collide;

repune_player * player;
counter * counter;
initfile=fopen("repune.ini","r");
fscanf(initfile,"%d",&INIT_NPLAYERS);

counter=calloc(sizeof(counter),INIT_NPLAYERS);
player=calloc(sizeof(repune_player),INIT_NPLAYERS);
if(player==NULL){
    perror(NULL);
    exit(-1);
}

world = world_init();
rect.x=rect.y=0;
rect.w=screen->w*85/100;
rect.h=screen->h;

rectc.x=(screen->w*85/100)+1;
rectc.y=0;
rectc.w=(screen->w*15/100)-1;
rectc.h=screen->h;

display = display_init(screen,rect.w,rect.h,rect);
displayc = display_init(screen,rectc.w,rectc.h,rectc);
display_setbackground(display,"resources/background.bmp");
display_clean(display);
display_clean(displayc);
collide = collide_init (display_width (display), display_height (display));


for(i=0;i<INIT_NPLAYERS;i++){
    fscanf(initfile," %s ",INIT_PLAYER_NAME);
    fscanf(initfile," %d ",&INIT_PLAYER_COLOR);
    fscanf(initfile," %d ",&INIT_PLAYER_POSX);
    fscanf(initfile," %d ",&INIT_PLAYER_POSY);
    fscanf(initfile," %d ",&INIT_PLAYER_LEFTKEY);
    fscanf(initfile," %d ",&INIT_PLAYER_RIGHTKEY);
    switch(INIT_PLAYER_COLOR){
    case 0:
	INIT_PLAYER_COLOR=RED;
	break;
    case 1:
    	INIT_PLAYER_COLOR=BLUE;
	break;
    case 2:
    	INIT_PLAYER_COLOR=GREEN;
	break;
    case 3:
    	INIT_PLAYER_COLOR=WHITE;
	break;
    default:
    	INIT_PLAYER_COLOR=BLACK;
    }
    
player[i] = player_init(world, collide, display, new_id(), INIT_PLAYER_POSX,INIT_PLAYER_POSY,3,3, 0.0, 0.04, 12,100, INIT_PLAYER_COLOR, WHITE);
counter[i]=counter_init(world,displayc, new_id(), player_getid(player[i]),display_width (displayc)/100,(display_height (displayc)/INIT_NPLAYERS)*i+5,INIT_PLAYER_COLOR);

if(INIT_PLAYER_LEFTKEY)
player_setmoused(player[i]);

world_attach_object(world, object_init(player[i],&player_object_operations));
world_attach_object(world, object_init(counter[i],&counter_object_operations));
}



then=SDL_GetTicks ();
while((aa=SDL_GetTicks ()),world_step(world)){
    display_update(display);
    display_update(displayc);
    while(SDL_GetTicks()-aa <15);
    frames++;
    }
world_destroy(world);
display_destroy(display);
display_destroy(displayc);
collide_destroy(collide);
}



	/* Print out some timing information */
now = SDL_GetTicks ();
if (now > then)
  {
	  printf ("%2.2f frames per second\n",
		  ((double) frames * 1000) / (now - then));
  }
SDL_Quit ();
return (0);
}
