/*! \file
    Object ADT implementation.
*/

#include<list.h>
#include<stdlib.h>
#include<object.h>


/*! You must call this function before using the object.
	\bug There isn't any error check in it (out of memory)
	\param priv The private data of the actual object implementation.
	\param object_ops The object operations overloaded for this kind of object.
    \return An object
*/
object object_init(void * priv, struct object_operations * object_ops){
    object obj;
    obj = malloc(sizeof(struct object));
    obj->object_ops = object_ops;
    obj->priv=priv;
    INIT_LIST_HEAD(&obj->all_objects);
    INIT_LIST_HEAD(&obj->list);
    return obj;
};

/*! \brief It destroys an object.

It frees the resources of the object. You must call it when
are not going to use the object anymore (ex. player dead)

    \param obj An initialized object
    \return Nothing
*/
void object_destroy(object obj){
//    obj_destroy(obj);
    free(obj);
};


/* que pasa cuando choca por ej, una viborita a un powerup?
Debe colisionar: el coolide debe retornar que choco con el poeweup
ir con el id a algun lugar y conseguir que tipo es el que 
hay que poner algo para poder avisar a alguien que ya hizo el step
que este obj lo acaba de chocar y en el caso de que se haga algo
especial como por ej pasarlo por encima el otro deberia hacer
algo al respecto (x ej desaparecer en el caso de el powerup o
sumar puntos en el caso de un choque)*/

/* list of object */
