/*! \file 
    Object interface.
*/
#ifndef PUNE_OBJECT
#define PUNE_OBJECT
#include<list.h>
#include<SDL.h>
#include<action.h>

/*object */
#define obj_step(o) o->object_ops->obj_step(o->priv)
#define obj_action(o, a) o->object_ops->obj_action(o->priv, a)
#define obj_alive(o) o->object_ops->obj_alive(o->priv)
#define obj_show(o) o->object_ops->obj_show(o->priv)
#define obj_destroy(o) o->object_ops->obj_destroy(o->priv)


/*!
	\brief All the permited operations an object can do.
	
	Sort of function pointers that contains the overloaded versions
	of opoerations of each type of object. All this operations
	expect a private data pointer, generaly used for maintan the
	information relative to the especific object (ex. poition). For
	add an object you only have to code this functions and reister
	it on the world.
*/

struct object_operations{
    int (*obj_step)(void *); 	/*!<Do what you are ment to do baby!.*/
    int (*obj_action)(void *, SDL_Event * action); /*!<This function codes what to do when this object recives an event(ex. event crash -> die).*/
    int (*obj_alive)(void *); /*!<This returns if the object is active or alive.*/
    void (*obj_destroy)(void *); /*!<This is just for release the resources it cosumes. It is called when the object "die" or finish the job.*/
    int (*obj_show)(void *); /*!< This function draw the thhing in the display, it's separated from step becase of performance reasons.(I think)*/
};


/*!
	\brief A generic object
*/
struct object{
    struct object_operations * object_ops; /*!< The object operations.*/
    void * priv; /*!<Private data for the object, all the operation recives it as a parameter.*/
    list_t all_objects;  /*!<Hook for the list of all objects.(Iternal use)*/
    list_t list;	 /*!<Hook for an internal list.(Iternal use)*/
};

typedef struct object * object;

//! It initializes an object
object object_init(void * priv, struct object_operations * object_ops);
void object_destroy(object);


/* que pasa cuando choca por ej, una viborita a un powerup?
Debe colisionar: el coolide debe retornar que choco con el poeweup
ir con el id a algun lugar y conseguir que tipo es el que 
hay que poner algo para poder avisar a alguien que ya hizo el step
que este obj lo acaba de chocar y en el caso de que se haga algo
especial como por ej pasarlo por encima el otro deberia hacer
algo al respecto (x ej desaparecer en el caso de el powerup o
sumar puntos en el caso de un choque)*/

/* list of object */
#endif
