#ifndef _PUNE_PARTICLE_
#define _PUNE_PARTICLE_
#include<SDL.h>
#include<action.h>
#include<world.h>
#include<display.h>
#include<object.h>
#include<math.h>

#define _PARTICLE_C_
struct particle{
    world world;
    display display;
    float x,y;
    float angle;
    int lifetime;
    Uint32 oldcolor;
    Uint32 color;
    id id;
    int step;
};

typedef struct particle * particle;
#include<particle.h>


particle particle_init(world world, display display, id id, float x, float y, float angle, int lifetime, Uint32 color){
    particle particle=malloc(sizeof(struct particle));
    particle->world=world;
    particle->display=display;
    particle->x=x;
    particle->y=y;
    particle->angle=angle;
    particle->lifetime=lifetime;
    particle->color=color;
    particle->id=id;
    particle->step=0;
    return particle;
};
void particle_destroy(particle particle){
    free(particle);
};

int particle_step(particle particle){
    if(particle->lifetime<particle->step)
	return 0;
//    if(particle->step) display_drawpixel(display, particle->x, particle->y, particle->oldcolor);
    particle->x=particle->x+(cos(particle->angle));
    particle->y=particle->y+(sin(particle->angle));
//    particle->oldcolor = display_getpixel(display, particle->x, particle->y);
    display_drawpixel(particle->display, particle->x, particle->y, particle->color);
    particle->step++;
return 1;
};
int particle_alive(particle particle){
    return (particle->lifetime>particle->step);
};

int particle_show(particle particle){
    display_drawpixel(particle->display, particle->x, particle->y, particle->color);
    return 1;
};

int particle_action(particle particle, SDL_Event * action){
    return 0;
};

#endif
