#ifndef _REPUNE_PLAYER_
#define _REPUNE_PLAYER_

#include<stdlib.h>
#include<math.h>
#include<SDL.h>
#include<SDL_utils.h>
#include<action.h>
#include<world.h>
#include<particle.h>
#include<collide.h>


struct repune_player
{
	id id;
	float angle;
	float rotspeed;
	int blanks_steps;
	int draw_steps;
	action action;
	world world;
	display display;
	collide collide;
	int step;
	float x, y;
	int h, w;
//control
	int moused;
	SDLKey leftkey;
	SDLKey rightkey;
	SDL_Surface *sprite;
	SDL_Surface *blank;
//	int maxframes, maxangles;
};

typedef struct repune_player *repune_player;

repune_player
player_init (world world, collide collide, display display, id id, int x, int y, int w, int h, float angle, float rotspeed,
	     int blanks_steps, int draw_steps, Uint32 Color, Uint32 Colorblank)
{
	repune_player pp;
	pp = malloc (sizeof (struct repune_player));
	pp->world = world;
	pp->collide = collide;
	pp->display = display;
	pp->id = id;
	pp->x = (float) x;
	pp->y = (float) y;
	pp->angle = angle;
	pp->action = STRAIGHT;
	pp->step = 0;
	pp->rotspeed = rotspeed;
	pp->blanks_steps = blanks_steps;
	pp->draw_steps = draw_steps;
//load all bmps @@@
//	pp->maxframes = pp->maxangles = 1;
//	pp->anim = SDL_LoadBMP (file);
//	pp->sprite = SDL_LoadBMP ("bitmap.bmp");
	pp->sprite = SDL_CreateSurface(w, h);
	SDL_FillRect(pp->sprite, NULL, Color);
//	SDL_UpdateRect(pp->sprite, 0,0,w,h);
	pp->blank = SDL_CreateSurface(w, h);
//	SDL_UpdateRect(pp->blank, 0,0,w,h);
	SDL_FillRect(pp->blank, NULL, Colorblank);
//	SDL_UpdateRect(pp->blank, 0,0,w,h);
	if (!pp->sprite || !pp->blank)
	  {
		  fprintf (stderr, "Unable to create Surface.\n");
		  exit (-1);
	  }
	pp->w = w;
	pp->h = h;
	pp->moused=0;
	pp->leftkey=SDLK_LEFT;
	pp->rightkey=SDLK_RIGHT;
	return pp;
}

void
player_setkeys(repune_player pp, SDLKey left, SDLKey right){
	pp->leftkey=left;
	pp->rightkey=right;
	pp->moused=0;
}

void
player_setmoused(repune_player pp){
	pp->moused=1;
}

void
player_destroy (repune_player pp)
{
//free all bmps @@@
	SDL_FreeSurface (pp->sprite);
	SDL_FreeSurface (pp->blank);
	free (pp);
}

SDL_Rect
player_getpos (repune_player pp)
{
	static SDL_Rect rect;
	rect.x = (int) pp->x;
	rect.y = (int) pp->x;
	rect.w = pp->w;
	rect.h = pp->h;
	return rect;
};
int
player_getxpos (repune_player pp)
{
	return (int) pp->x;
}

int
player_getypos (repune_player pp)
{
	return (int) pp->y;
}

int player_action (repune_player pp, SDL_Event * event)
{
    static Uint8 *keystate;
//  Uint8 mousek;
    if (pp->action == DEAD)
	return 0;

    switch (event->type) {
    case SDL_USEREVENT:
	//pp->action = event->user.code;
	break;
    case SDL_KEYUP:
    case SDL_KEYDOWN:
	if (!pp->moused) {
	    keystate = SDL_GetKeyState (NULL);
	    pp->action = STRAIGHT;
	    if (keystate[pp->leftkey])
		pp->action = LEFT;
	    else if (keystate[pp->rightkey])
		pp->action = RIGHT;
	}
	break;
    case SDL_MOUSEBUTTONDOWN:
    case SDL_MOUSEBUTTONUP:
	if (pp->moused) {
//   mousek = SDL_GetMouseState (NULL, NULL);
	    if (event->button.state == SDL_PRESSED)
		switch (event->button.button) {
		case SDL_BUTTON_LEFT:
		    pp->action = LEFT;
		    break;
		case SDL_BUTTON_RIGHT:
		    pp->action = RIGHT;
		    break;
		default:
		    pp->action = STRAIGHT;
		}
	    else {
		pp->action = STRAIGHT;
	    }
	    break;
    default:
	    break;

	}
    }
    return 1;
};

void
player_actualize_pos (repune_player pp)
{
	switch (pp->action)
	  {
	  case LEFT:
		  pp->angle -= pp->rotspeed;
		  break;
	  case RIGHT:
		  pp->angle += pp->rotspeed;
		  break;
	  case STRAIGHT:
	  default:
		  break;
	  }
	pp->x += cos (pp->angle);
	pp->y += sin (pp->angle);
//	printf ("X:%f  Y:%f\n", pp->x, pp->y);
}
extern SDL_Surface * screen;
int
player_step (repune_player pp)
{
	world world;
	SDL_Rect rect;
	float angle;
//      action newaction;
	collide collide;
	display display;
	id id;
	world = pp->world;

	collide = pp->collide;
	display = pp->display;

/*dependiendo de en que accion estoy giro o no si la accion hace algo
sobre la posicion nueva*/

	switch (pp->action)
	  {
	  case LEFT:
		  angle = pp->angle - pp->rotspeed;
		  break;
	  case RIGHT:
		  angle = pp->angle + pp->rotspeed;
		  break;
	  case STRAIGHT:
		  angle = pp->angle;
	  default:
		  break;
	  }

//me muevo en un Rect auxiliar
	rect.x = (int) (pp->x + cos (angle));
	rect.y = (int) (pp->y + sin (angle));

	if ((int) rect.x != (int) pp->x || (int) rect.y != (int) pp->y)
	  {
		  rect.w = pp->w;
		  rect.h = pp->h;
		  switch (id = collide_who (collide, (int) (pp->x + cos (angle)*(pp->w*1.5)), (int) (pp->y + sin (angle)*(pp->h*1.5))))
		    {
		    case NONE:

			    player_actualize_pos (pp);
			    // pp->posanim++;
			    if((pp->step%(pp->blanks_steps+pp->draw_steps))<pp->draw_steps){    
				//SDL_FillRect(screen, &rect, SDL_MapRGB (screen->format, 0xff, 0x00, 0x00));
				//SDL_UpdateRects(screen, 1, &rect);
				    collide_put (collide, rect, pp->id);
				    display_draw(display, pp->sprite, &rect);
			    }else
			    	    display_draw(display, pp->blank, &rect);
			    break;
			    
		    default:
//		    printf("	Collide!! Xold:%d Yold:%d  X:%d Y:%d \n", oldrect.x, oldrect.y ,rect.x,rect.y);
{
    int i;
    for (i = 0; i < 10; i++)
	world_attach_object (world,
			     obj_particle (pp->world, pp->display, new_id (), pp->x,
					   pp->y,
					   pp->angle +
					   (((float) rand () /
					     (float) RAND_MAX) - 0.5) * 1,
					   (int) (20.0 * (float) rand () /
						  (float) RAND_MAX),
					   SDL_MapRGB (pp->sprite->format,
						       0xf0, 0x0f, 0xff)));

}
{
static	    SDL_Event event;
	    event.type = SDL_USEREVENT;
	    event.user.code = DEAD;
	    event.user.data1 = (void * )pp;
	    SDL_PushEvent( & event);
}

			    pp->action = DEAD;
		    }

	  }
	else
		player_actualize_pos (pp);
		
	pp->step++;
	return 0;
};

id
player_getid (repune_player pp)
{
	return pp->id;
};
int
player_alive (repune_player pp)
{
	return (pp->action != DEAD);
};

#endif
