/*!\file sprite.h
Sprite object interface. Here a sprite is a thing that desn't do much more
than simply display itself in the screen.
*/
#ifndef _PUNE_PARTICLE_
#define _PUNE_PARTICLE_
#include<SDL.h>
#include<action.h>
#include<object.h>
/*Lo decidi, el contructor de un  objeto espera el display y el collide,
ademas en la obj_ops debe haber una funcion para destruir mejor*/

#ifndef _SPRITE_C_
typedef void * sprite;
#endif

//! Initializes a sprite.
sprite sprite_init(world, display display, id, int x, int y, int w, int h,int lifetime, char * bitmap);
//! Destroy a sprite object.
void sprite_destroy(sprite);

//! A function part of the object operations.
int sprite_step(sprite);
//! A function part of the object operations.
int sprite_alive(sprite);
//! A function needed to create an object to attach to a world.
int sprite_show(sprite);
//! A function needed to create an object to attach to a world.
int sprite_action(sprite, SDL_Event * action);


//! Macro to make it easy to construct an object of a sprite.
#define obj_sprite(world,id,x,y,angle,lifetime,color)\
object_init(sprite_init(world,id,x,y,angle,lifetime,color),&sprite_object_operations)


//! Template of the object_operation related with a sprite.
struct object_operations sprite_object_operations ={
    obj_step: &sprite_step,
    obj_action: &sprite_action,
    obj_alive: &sprite_alive,
    obj_destroy: &sprite_destroy
};

//! Template of a sprite object.
struct object sprite_obj_template ={
    object_ops: &sprite_object_operations,
};


#endif
